#!/usr/bin/perl

###############################################################################
# setup.cgi                                                                   #
###############################################################################
#
# ImageFolio v 2.1 by BizDesign, Inc.
# written by Greg Raaum, webmaster@imageFolio.com
# Available from http://www.ImageFolio.com
# ---------------------------------------------------------------------------
# PROGRAM NAME : ImageFolio 2.1
# VERSION : 2.1
# LAST MODIFIED : 04/17/2000
# ===========================================================================
# COPYRIGHT NOTICE :
#
# Copyright (c) 1999-2000 BizDesign, Inc. All Rights Reserved.
# Selling the code for this program without prior written consent is
# expressly forbidden.
#
# Obtain written permission before redistributing this software over the 
# Internet or in any other medium.  In all cases copyright and header must
# remain intact.
#
# Feel free to modify the code of this program to suit your likings. 
#
# Although this program has been thoroughly tested on BizDesign's servers, we
# do not warrant that it works on all servers and will not be held liable
# for anything, including but not limited to, misusage, error, or loss of data.
#
# Use at your own risk!
###############################################################################

$|++;   # flush output

require "../config.pl";     # add the full path here if you have probs
require "admin_config.pl";  # add the full path here if you have probs

&parse;
&load_values;
if ($action eq "adduser") { &step_two; }
else                      { &step_one; }
exit;

###############################################################################
# STEP ONE
# called if we haven't added a user yet
###############################################################################
sub step_one {

   print "Content-type: text/html\n\n";

print qq|
<html>
<head>
<title>ImageFolio Administration User Account Setup</title>

</head>

<body bgcolor="#ffffff">

<form method=post action="$ENV{'SCRIPT_NAME'}">
<input type=hidden name="action" value="adduser">


<table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%"><tr>
<td align=center>

<table border=0 cellspacing=0 cellpadding=0 width=600 bgcolor="#000000"><tr>
<td align=center valign=middle>

<table border=0 cellspacing=1 cellpadding=10 width=600 bgcolor="#000000"><tr bgcolor="#ffcc00">
<td align=center>

<table border=0 cellspacing=0 cellpadding=0 width="100%" bgcolor="#ffffff"><tr><td align=center>
<table border=0 cellspacing=1 cellpadding=0 width="100%"><tr bgcolor="#000000">
<td>&nbsp;&nbsp;<img src="http://www.imagefolio.com/clients/if_images/logo.gif" border=0 alt="ImageFolio Login" width=172 height=54></td>
</tr></table></td></tr></table>

<br>

<center><font face="Verdana,Arial,Helvetica" size="+1"><b>User Account Setup</font></b></font>


<br><table border=0 cellspacing=0 cellpadding=4 width="100%"><tr>

<td colspan=3>
<$admin_font>To <b>Add a New User</b> please enter
a username and password combination below.</font><br></td></tr>

<tr><td colspan=3>&nbsp;</td></tr>

<tr><td align=right><$admin_font><b>Username</b></font></td>
<td><input type=text maxlength=50 name="login" size=20></td>
<td nowrap><$admin_small_font>Min 5 characters, no spaces</font></td></tr>

<tr><td colspan=3>&nbsp;</td></tr>

<tr><td colspan=3><$admin_font>A password is
required to login.  To make your administration area more secure, please use
a <b>mixed case combination of at least 6 letters and numbers.<b></font><br></td></tr>

<tr><td colspan=3>&nbsp;</td></tr>

<tr><td align=right><$admin_font><b>Password</b></font></td>
<td><input type=password maxlength=50 name="password" size=10></td>
<td nowrap><$admin_small_font>Min 6 characters, no spaces</font></td></tr>

<tr><td align=right nowrap><$admin_font><b>Retype Password</b></font></td>
<td><input type=password maxlength=50 name="sec_password" size=10></td>
<td>&nbsp;</td></tr>

<tr><td colspan=3>&nbsp;</td></tr>

<tr><td colspan=3><$admin_font>Your <b>Name and Email Address
are required</b> to personalize your User Account.</font><br></td></tr>

<tr><td colspan=3>&nbsp;</td></tr>

<tr><td align=right><$admin_font><b>First Name</b></font></td>
<td colspan=2><input type=text maxlength=50 name="firstname" size=35></td>
</tr>

<tr><td align=right><$admin_font><b>Last Name</b></font></td>
<td colspan=2><input type=text maxlength=50 name="lastname" size=35></td>
</tr>

<tr><td align=right><$admin_font><b>Email Address</b></font></td>
<td colspan=2><input type=text maxlength=50 name="email" size=35></td>
</tr>

<tr><td colspan=3>&nbsp;</td></tr>

<tr><td colspan=3 align=center><$admin_font>Please set <b>User Permissions</b> for this user below:<b></font><br></td></tr>

<tr><td colspan=3>&nbsp;</td></tr>

<tr><td colspan=3 align=center>
<table border=0 cellspacing=0 cellpadding=0 width="400" bgcolor="#000000"><tr><td align=center valign=middle>
<table border=0 cellspacing=1 cellpadding=4 width="100%"><tr bgcolor="#ff0000">
<td width="80%"><$admin_font color="#ffffff"><b>Allow this user to...</b></font></td>
<td align=center width="10%"><$admin_font color="#ffffff"><b>Yes</b></font></td>
<td align=center width="10%"><$admin_font color="#ffffff"><b>No</b></font></td></tr>

<tr bgcolor="#dddddd">
<td><$admin_font><b>Add Keywords and Captions</b> ?</font></td>
<td align=center><input type=radio name="desc_per" value=Yes checked></td>
<td align=center><input type=radio name="desc_per" value=No></td>
</tr>

<tr bgcolor="#ffffff">
<td><$admin_font><b>Upload Media</b> ?</font></td>
<td align=center><input type=radio name="upload_per" value=Yes checked></td>
<td align=center><input type=radio name="upload_per" value=No></td>
</tr>

<tr bgcolor="#dddddd">
<td><$admin_font><b>Add Categories</b> ?</font></td>
<td align=center><input type=radio name="addcat_per" value=Yes checked></td>
<td align=center><input type=radio name="addcat_per" value=No></td>
</tr>

<tr bgcolor="#ffffff">
<td><$admin_font><b>Rename Categories</b> ?</font></td>
<td align=center><input type=radio name="rencat_per" value=Yes checked></td>
<td align=center><input type=radio name="rencat_per" value=No></td>
</tr>

<tr bgcolor="#dddddd">
<td><$admin_font><b>Delete Categories</b> ?</font></td>
<td align=center><input type=radio name="delcat_per" value=Yes checked></td>
<td align=center><input type=radio name="delcat_per" value=No></td>
</tr>

<tr bgcolor="#ffffff">
<td><$admin_font><b>Rebuild the Image Index</b> ?</font></td>
<td align=center><input type=radio name="build_per" value=Yes checked></td>
<td align=center><input type=radio name="build_per" value=No></td>
</tr>

<tr bgcolor="#dddddd">
<td><$admin_font><b>Add New Users</b> ?</font></td>
<td align=center><input type=radio name="addusr_per" value=Yes checked></td>
<td align=center><input type=radio name="addusr_per" value=No></td>
</tr>

<tr bgcolor="#ffffff">
<td><$admin_font><b>Modify Other Users</b> ?</font></td>
<td align=center><input type=radio name="modusr_per" value=Yes checked></td>
<td align=center><input type=radio name="modusr_per" value=No></td>
</tr>

<tr bgcolor="#dddddd">
<td><$admin_font><b>Delete Other Users</b> ?</font></td>
<td align=center><input type=radio name="delusr_per" value=Yes checked></td>
<td align=center><input type=radio name="delusr_per" value=No></td>
</tr>

</table></td></tr></table></td></tr></table>

<br><input type=submit value="Add User">

</td></tr></table></td></tr></table>

<br><br>

</font><br><br><hr size=1 noshade width=400>
<$admin_small_font>&copy; Copyright 1999-2000 BizDesign, Inc.<br></font>

</td></tr></table>

</center>
</form>
</body>
</html>
|;
}

###############################################################################
# STEP TWO
# add a username and password to the database
###############################################################################
sub step_two {

   $login =~ s/ //g;
   $password =~ s/ //g;
   $plength = length($password);
   $llength = length($login);


# WE MAKE SURE THAT THIS USERNAME IS AVAILABLE FIRST

   open (FILE,"$userdb") || die "Content-type: text/html\n\nCan't Open $userdb: $!\n";
   my(@LINES)=<FILE>;
   close(FILE);
   chomp @LINES;

   foreach $line (@LINES) {
      ($username) = split(/\|/, $line);

      if (lc($username) eq lc($login)) {
         print &Error('The Username you requested is already in use by another user.');
         exit;
      }
   }


   if    (!$login)                    { print &Error('You must enter a Username.');                      exit; }
   elsif (!$email)                    { print &Error('You must enter your Email Address.');              exit; }
   elsif (!$password)                 { print &Error('You must enter a Password.');                      exit; }
   elsif (!$sec_password)             { print &Error('You must enter your Password twice.');             exit; }
   elsif ($sec_password ne $password) { print &Error('Your Passwords do not match.');                    exit; }
   elsif ($plength < 6)               { print &Error('Your Password must be at least six characters.');  exit; }
   elsif ($llength < 5)               { print &Error('Your Username must be at least five characters.'); exit; }
   elsif (!$firstname)                { print &Error('You must enter your First Name.');                 exit; }
   elsif (!$lastname)                 { print &Error('You must enter your Last Name.');                  exit; }


# BELOW WE CREATE A RANDOM DIGITAL ID FOR THE USER JUST IN CASE WE NEED TO USE IT LATER

   $userid  = reverse time;
   $userid  = substr($userid, 0, 4);
   $userid  = $userid * 1321;
   $userid  = rand $userid;
   $newpass = crypt($password, "MM");

# HERE WE SAVE ALL OF THE PERSONAL INFORMATION FOR THE USER IN THE USER'S DATABASE

   open (USERDB,">>$userdb") || print &Error('Could not open the user database!');
   flock(USERDB, 2);
   print USERDB "$login|$newpass|$userid|$email|$firstname|$lastname|";
   print USERDB "$desc_per|$upload_per|$addcat_per|$rencat_per|";
   print USERDB "$delcat_per|$build_per|$addusr_per|$modusr_per|$delusr_per\n";
   flock(USERDB, 8);
   close(USERDB);


   print "Content-type: text/html\n\n";

print qq|
<html>
<head>
<title>ImageFolio Administration User Added!</title>
</head>
<body bgcolor="#ffffff">

<center><font face="Verdana,Arial,Helvetica" size="+1"><b>User Added Successfully!</b></font>

<br><table border=0 cellspacing=0 cellpadding=10 width="600"><tr>

<td><$admin_font>
<b>Your ImageFolio Administration User Account has been added.  Here is the information you provided. 
Please print or save this information for your records.</b></font><br><pre>

User Authentication Information
==========================================================================
Name:               $firstname $lastname
Email:              $email
Username:           $login
Password:           $password
Login Location:     <a href="$adminurl">$adminurl</a>


User Permissions
==========================================================================
Add Descriptions:   $desc_per
Upload Media:       $upload_per
Add Categories:     $addcat_per
Rename Categories:  $rencat_per
Delete Categories   $delcat_per
Build Index:        $build_per
Add Users:          $addusr_per
Modify Users:       $modusr_per
Delete Users:       $delusr_per

</pre><br>

<table border=1 cellspacing=0 cellpadding=15 width="100%">
<tr><td align=center><$admin_font><b>You may now Login by
clicking on the link below:</b><br><br><a href="$adminurl"><b>Login to ImageFolio Administration</b></a></font></td>

</tr></table><br>
</td></tr></table>

</body>
</html>
|;
}

###############################################################################
# ERROR
# shows error message if form not filled out correctly
###############################################################################
sub Error{

   print "Content-type: text/html\n\n";
   local ($whoops) = @_;

print qq|
<script language="JavaScript">
<!--
function help(){
window.alert("Help\\n\\nThis error message is displayed either because I was not able to understand your input or your input was incorrect.");
}
//-->
</script>

</head>

<body bgcolor="#ffffff" marginwidth=0 marginheight=0 topmargin=0 leftmargin=0>

<form>

<table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%"><tr><td valign=middle align=center>
<table border=2 cellspacing=0 cellpadding=0 width="350" bgcolor="#000000"><tr><td>
<table border=0 cellspacing=0 cellpadding=3 width="350"><tr bgcolor="000000">
<td nowrap><$admin_font color="#ffffff"><strong>Error!</strong></font></td>
<td align=right nowrap><$admin_font><b><INPUT TYPE="button" VALUE=" ? " onClick="help()">&nbsp;<INPUT TYPE="button" VALUE=" X " onClick="history.go(-1)"></b></font></td></tr>

<tr bgcolor="#eeeeee">
<td colspan=2><table border=0 cellspacing=0 cellpadding=5 width="100%"><tr>
<td><$admin_font><b><font color="#ff0000">$whoops</font></b><br><br>If the button below does not take you back, please use your browser's back button to go back and try again.<br><br></font></td>
</tr></table>

<center><$admin_font><INPUT TYPE="button" VALUE="     OK     " onClick="history.go(-1)"></font></center>

</td></tr></table></td></tr></table></td></tr></table>
</form>
|;

exit;
}

###############################################################################
# LOAD VALUES
# created variables for our form information
###############################################################################
sub load_values {
   $action       = $FORM{'action'};
   $password     = $FORM{'password'};
   $sec_password = $FORM{'sec_password'};
   $firstname    = $FORM{'firstname'};
   $lastname     = $FORM{'lastname'};
   $email        = $FORM{'email'};
   $login        = $FORM{'login'};
   $desc_per     = $FORM{'desc_per'};
   $upload_per   = $FORM{'upload_per'};
   $addcat_per   = $FORM{'addcat_per'};
   $rencat_per   = $FORM{'rencat_per'};
   $delcat_per   = $FORM{'delcat_per'};
   $build_per    = $FORM{'build_per'};
   $addusr_per   = $FORM{'addusr_per'};
   $modusr_per   = $FORM{'modusr_per'};
   $delusr_per   = $FORM{'delusr_per'};
}

###############################################################################
# PARSE
# parses the form data
###############################################################################
sub parse {
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      $name =~ tr/+/ /;
      $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<.*?>//g;
      $value =~ s/\"/\&quot\;/g;
      $value =~ s/\&/\&amp\;/g;
      $value =~ s/<!--(.|\n)*-->//g;
      $FORM{$name} = $value;
   }
}